<?php
namespace Glopal\Connector\Api\Data;

interface OrderAttributeInterface
{
    /**
     * Main table name
     */
    public const TABLE_NAME = 'gl_sales_order_attribute';

    /**#@+
     * Constants for keys of data array.
     * Identical to the name of the getter in snake case.
     */
    public const ENTITY_ID = 'entity_id';
    public const ORDER_ID = 'order_id';

    public const EXCHANGE_RATE = 'exchange_rate';
    public const FROM_CURRENCY = 'from_currency';
    public const TO_CURRENCY = 'to_currency';

    public const CUSTOMER_ORIGIN_EMAIL = 'customer_origin_email';
    public const CUSTOMER_SHIPPING_ADDRESS = 'customer_shipping_address';

    public const TRANSACTION_ID = 'transaction_id';

    public const BASE_EXTRA_AMOUNT_NET = 'base_extra_amount_net';
    public const EXTRA_AMOUNT_NET = 'extra_amount_net';
    public const BASE_EXTRA_TAX_ON_AMOUNT = 'base_extra_tax_on_amount';
    public const EXTRA_TAX_ON_AMOUNT = 'extra_tax_on_amount';
    /**#@-*/

    /**
     * Get ID
     *
     * @return int|null
     */
    public function getId(): ?int;

    /**
     * Set ID
     *
     * @param int $id
     * @return void
     */
    public function setId(int $id): void;

    /**
     * Get order ID
     *
     * @return int|null
     */
    public function getOrderId(): ?int;

    /**
     * Set order ID
     *
     * @param int $orderId
     * @return void
     */
    public function setOrderId(int $orderId): void;

    /**
     * Get exchange rate
     *
     * @return float|null
     */
    public function getExchangeRate(): ?float;

    /**
     * Set exchange rate
     *
     * @param float $rate
     * @return void
     */
    public function setExchangeRate(float $rate): void;

    /**
     * Get from currency
     *
     * @return string|null
     */
    public function getFromCurrency(): ?string;

    /**
     * Set from currency
     *
     * @param string $currency
     * @return void
     */
    public function setFromCurrency(string $currency): void;

    /**
     * Get to currency
     *
     * @return string|null
     */
    public function getToCurrency(): ?string;

    /**
     * Set to currency
     *
     * @param string $currency
     * @return void
     */
    public function setToCurrency(string $currency): void;

    /**
     * Get customer origin email
     *
     * @return string|null
     */
    public function getCustomerOriginEmail(): ?string;

    /**
     * Set customer origin email
     *
     * @param string $email
     * @return void
     */
    public function setCustomerOriginEmail(string $email): void;

    /**
     * Get customer shipping address
     *
     * @return array|null
     */
    public function getCustomerShippingAddress(): ?array;

    /**
     * Set customer shipping address
     *
     * @param array $shippingAddress
     * @return void
     */
    public function setCustomerShippingAddress(array $shippingAddress): void;

    /**
     * Get Transaction ID
     *
     * @return string|null
     */
    public function getTransactionId(): ?string;

    /**
     * Set Transaction ID
     *
     * @param string $transactionId
     * @return void
     */
    public function setTransactionId(string $transactionId): void;

    /**
     * Get base extra amount
     *
     * @return float
     */
    public function getBaseExtraAmount(): float;

    /**
     * Set base extra amount
     *
     * @param float $amount
     *
     * @return void
     */
    public function setBaseExtraAmount(float $amount): void;

    /**
     * Get extra amount
     *
     * @return float
     */
    public function getExtraAmount(): float;

    /**
     * Set base extra amount
     *
     * @param float $amount
     *
     * @return void
     */
    public function setExtraAmount(float $amount): void;

    /**
     * Get base extra tax on amount
     *
     * @return float
     */
    public function getBaseExtraTaxOnAmount(): float;

    /**
     * Set base extra tax on amount
     *
     * @param float $amount
     *
     * @return void
     */
    public function setBaseExtraTaxOnAmount(float $amount): void;

    /**
     * Get extra tax on amount
     *
     * @return float
     */
    public function getExtraTaxOnAmount(): float;

    /**
     * Set extra tax on amount
     *
     * @param float $amount
     *
     * @return void
     */
    public function setExtraTaxOnAmount(float $amount): void;
}
