<?php
namespace Glopal\Connector\Api\Data;

interface OrderItemTotalCostInterface
{
    /**
     * Main table name
     */
    public const TABLE_NAME = 'gl_sales_order_item_tcc';

    /**#@+
     * Constants for keys of data array.
     * Identical to the name of the getter in snake case.
     */
    public const ENTITY_ID = 'entity_id';
    public const ORDER_ITEM_ID = 'order_item_id';
    public const ORDER_TCC_ID = 'order_tcc_id';
    public const BASE_DUTY_AMOUNT = 'base_duty_amount';
    public const DUTY_AMOUNT = 'duty_amount';
    public const BASE_TAX_ON_DUTY = 'base_tax_on_duty';
    public const TAX_ON_DUTY = 'tax_on_duty';
    public const DUTY_PERCENT = 'duty_percent';
    /**#@-*/

    /**
     * Get ID
     *
     * @return int|null
     */
    public function getId(): ?int;

    /**
     * Set ID
     *
     * @param int $id
     * @return void
     */
    public function setId(int $id): void;

    /**
     * Get Order Item ID
     *
     * @return int|null
     */
    public function getOrderItemId(): ?int;

    /**
     * Aet Order Item ID
     *
     * @param int $orderId
     * @return void
     */
    public function setOrderItemId(int $orderId): void;

    /**
     * Get Order TCC ID
     *
     * @return int|null
     */
    public function getOrderTccId(): ?int;

    /**
     * Set Order TCC ID
     *
     * @param int $orderTccId
     * @return void
     */
    public function setOrderTccId(int $orderTccId): void;

    /**
     * Get Base Duty Amount
     *
     * @return float
     */
    public function getBaseDutyAmount(): float;

    /**
     * Set Base Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setBaseDutyAmount(float $amount): void;

    /**
     * Get Duty Amount
     *
     * @return float
     */
    public function getDutyAmount(): float;

    /**
     * Set Base Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setDutyAmount(float $amount): void;

    /**
     * Get Base Tax On Duty Amount
     *
     * @return float
     */
    public function getBaseTaxOnDutyAmount(): float;

    /**
     * Set Base Tax On Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setBaseTaxOnDutyAmount(float $amount): void;

    /**
     * Get Tax On Duty Amount
     *
     * @return float
     */
    public function getTaxOnDutyAmount(): float;

    /**
     * Set Tax On Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setTaxOnDutyAmount(float $amount): void;

    /**
     * Get Duty Percent
     *
     * @return float
     */
    public function getDutyPercent(): float;

    /**
     * Set Duty Percent
     *
     * @param float $percent
     * @return void
     */
    public function setDutyPercent(float $percent): void;
}
