<?php
namespace Glopal\Connector\Api\Data;

interface OrderTotalCostInterface
{
    /**
     * Main table name
     */
    public const TABLE_NAME = 'gl_sales_order_tcc';

    /**#@+
     * Constants for keys of data array.
     */
    public const ENTITY_ID = 'entity_id';
    public const ORDER_ID = 'order_id';

    public const BASE_TOTAL_DUTY_AMOUNT = 'base_total_duty_amount';
    public const TOTAL_DUTY_AMOUNT = 'duty_total_amount';
    public const BASE_TOTAL_TAX_ON_DUTY = 'base_total_tax_on_duty';
    public const TOTAL_TAX_ON_DUTY = 'total_tax_on_duty';

    public const BASE_ITEMS_DUTY_AMOUNT = 'base_items_duty_amount';
    public const ITEMS_DUTY_AMOUNT = 'duty_items_amount';
    public const BASE_ITEMS_TAX_ON_DUTY = 'base_items_tax_on_duty';
    public const ITEMS_TAX_ON_DUTY = 'items_tax_on_duty';

    public const BASE_DISCOUNT_DUTY_AMOUNT = 'base_discount_duty_amount';
    public const DISCOUNT_DUTY_AMOUNT = 'discount_duty_amount';
    public const BASE_DISCOUNT_TAX_ON_DUTY = 'base_discount_tax_on_duty';
    public const DISCOUNT_TAX_ON_DUTY = 'discount_tax_on_duty';

    public const BASE_SHIPPING_DUTY_AMOUNT = 'base_shipping_duty_amount';
    public const SHIPPING_DUTY_AMOUNT = 'shipping_duty_amount';
    public const BASE_SHIPPING_TAX_ON_DUTY = 'base_shipping_tax_on_duty';
    public const SHIPPING_TAX_ON_DUTY = 'shipping_tax_on_duty';

    public const BASE_EXTRA_DUTY_AMOUNT = 'base_extra_duty_amount';
    public const EXTRA_DUTY_AMOUNT = 'extra_duty_amount';
    public const BASE_EXTRA_TAX_ON_DUTY = 'base_extra_tax_on_duty';
    public const EXTRA_TAX_ON_DUTY = 'extra_tax_on_duty';
    /**#@-*/

    /**
     * Get ID
     *
     * @return int|null
     */
    public function getId(): ?int;

    /**
     * Set ID
     *
     * @param int $id
     * @return void
     */
    public function setId(int $id): void;

    /**
     * Get Order ID
     *
     * @return int|null
     */
    public function getOrderId(): ?int;

    /**
     * Set Order ID
     *
     * @param int $orderId
     * @return void
     */
    public function setOrderId(int $orderId): void;

    /**
     * Get Base Total Duty Amount
     *
     * @return float
     */
    public function getBaseTotalDutyAmount(): float;

    /**
     * Set Base Total Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setBaseTotalDutyAmount(float $amount): void;

    /**
     * Get Total Duty Amount
     *
     * @return float
     */
    public function getTotalDutyAmount(): float;

    /**
     * Set Total Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setTotalDutyAmount(float $amount): void;

    /**
     * Get Base Total Tax On Duty Amount
     *
     * @return float
     */
    public function getBaseTotalTaxOnDutyAmount(): float;

    /**
     * Set Base Total Tax On Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setBaseTotalTaxOnDutyAmount(float $amount): void;

    /**
     * Get Total Tax On Duty Amount
     *
     * @return float
     */
    public function getTotalTaxOnDutyAmount(): float;

    /**
     * Set Total Tax On Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setTotalTaxOnDutyAmount(float $amount): void;

    /**
     * Get Base Items Duty Amount
     *
     * @return float
     */
    public function getBaseItemsDutyAmount(): float;

    /**
     * Set Base Items Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setBaseItemsDutyAmount(float $amount): void;

    /**
     * Get Items Duty Amount
     *
     * @return float
     */
    public function getItemsDutyAmount(): float;

    /**
     * Set Items Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setItemsDutyAmount(float $amount): void;

    /**
     * Get Base Items Tax On Duty Amount
     *
     * @return float
     */
    public function getBaseItemsTaxOnDutyAmount(): float;

    /**
     * Set Base Items Tax On Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setBaseItemsTaxOnDutyAmount(float $amount): void;

    /**
     * Get Items Tax On Duty Amount
     *
     * @return float
     */
    public function getItemsTaxOnDutyAmount(): float;

    /**
     * Set Items Tax On Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setItemsTaxOnDutyAmount(float $amount): void;

    /**
     * Get Base Discount Duty Amount
     *
     * @return float
     */
    public function getBaseDiscountDutyAmount(): float;

    /**
     * Set Base Discount Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setBaseDiscountDutyAmount(float $amount): void;

    /**
     * Get Discount Duty Amount
     *
     * @return float
     */
    public function getDiscountDutyAmount(): float;

    /**
     * Set Discount Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setDiscountDutyAmount(float $amount): void;

    /**
     * Get Base Discount Tax On Duty Amount
     *
     * @return float
     */
    public function getBaseDiscountTaxOnDutyAmount(): float;

    /**
     * Set Base Discount Tax On Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setBaseDiscountTaxOnDutyAmount(float $amount): void;

    /**
     * Get Discount Tax On Duty Amount
     *
     * @return float
     */
    public function getDiscountTaxOnDutyAmount(): float;

    /**
     * Set Discount Tax On Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setDiscountTaxOnDutyAmount(float $amount): void;

    /**
     * Get Base Shipping Duty Amount
     *
     * @return float
     */
    public function getBaseShippingDutyAmount(): float;

    /**
     * Set Base Shipping Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setBaseShippingDutyAmount(float $amount): void;

    /**
     * Get Shipping Duty Amount
     *
     * @return float
     */
    public function getShippingDutyAmount(): float;

    /**
     * Set Shipping Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setShippingDutyAmount(float $amount): void;

    /**
     * Get Base Shipping Tax On Duty Amount
     *
     * @return float
     */
    public function getBaseShippingTaxOnDutyAmount(): float;

    /**
     * Set Base Shipping Tax On Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setBaseShippingTaxOnDutyAmount(float $amount): void;

    /**
     * Get Shipping Tax On Duty Amount
     *
     * @return float
     */
    public function getShippingTaxOnDutyAmount(): float;

    /**
     * Set Shipping Tax On Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setShippingTaxOnDutyAmount(float $amount): void;

    /**
     * Get Base Extra Duty Amount
     *
     * @return float
     */
    public function getBaseExtraDutyAmount(): float;

    /**
     * Set Base Extra Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setBaseExtraDutyAmount(float $amount): void;

    /**
     * Get Extra Duty Amount
     *
     * @return float
     */
    public function getExtraDutyAmount(): float;

    /**
     * Set Extra Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setExtraDutyAmount(float $amount): void;

    /**
     * Get Base Extra Tax On Duty Amount
     *
     * @return float
     */
    public function getBaseExtraTaxOnDutyAmount(): float;

    /**
     * Set Base Extra Tax On Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setBaseExtraTaxOnDutyAmount(float $amount): void;

    /**
     * Get Extra Tax On Duty Amount
     *
     * @return float
     */
    public function getExtraTaxOnDutyAmount(): float;

    /**
     * Set Extra Tax On Duty Amount
     *
     * @param float $amount
     * @return void
     */
    public function setExtraTaxOnDutyAmount(float $amount): void;
}
