<?php

namespace Glopal\Connector\Block\Adminhtml\Form\Field;

use Glopal\Connector\Provider\ProductAttributeSetsProvider;
use Magento\Framework\View\Element\Context;
use Magento\Framework\View\Element\Html\Select;

class ProductAttributesSetSelect extends Select
{
    /** @var ProductAttributeSetsProvider */
    private $productAttributeSetsProvider;

    /**
     * @param Context $context
     * @param ProductAttributeSetsProvider $productAttributeSetsProvider
     * @param array $data
     */
    public function __construct(
        Context $context,
        ProductAttributeSetsProvider $productAttributeSetsProvider,
        array $data = []
    ) {
        parent::__construct($context, $data);

        $this->productAttributeSetsProvider = $productAttributeSetsProvider;
    }

    /**
     * Set "name" for <select> element
     *
     * @param string $value
     * @return $this
     */
    public function setInputName(string $value)
    {
        return $this->setName($value);
    }

    /**
     * Set "id" for <select> element
     *
     * @param string $value
     * @return $this
     */
    public function setInputId(string $value)
    {
        return $this->setId($value);
    }

    /**
     * Render block HTML
     *
     * @return string
     */
    public function _toHtml(): string
    {
        if (!$this->getOptions()) {
            $this->setOptions($this->productAttributeSetsProvider->getOptions());
        }

        return parent::_toHtml();
    }
}
