<?php

namespace Glopal\Connector\Block\Adminhtml\Order\View;

use Magento\Framework\Exception\LocalizedException;
use Magento\Sales\Block\Adminhtml\Order\AbstractOrder;

class ExtraCustomerInfo extends AbstractOrder
{
    /**
     * Retrieve customer origin email.
     *
     * @return string|null
     * @throws LocalizedException
     */
    public function getCustomerOriginEmail(): ?string
    {
        $order = $this->getOrder();

        $extensionAttributes = $order->getExtensionAttributes();
        if (!$extensionAttributes) {
            return null;
        }

        $orderAttribute = $extensionAttributes->getGlAttribute();
        if (!$orderAttribute) {
            return null;
        }

        return $orderAttribute->getCustomerOriginEmail();
    }
}
