<?php

namespace Glopal\Connector\Controller\Adminhtml\Connector;

use Glopal\Connector\Helper\Installation;
use Magento\Framework\App\Action\HttpGetActionInterface;
use Magento\Framework\App\Action\HttpPostActionInterface;
use Magento\Framework\Controller\Result\Json;
use Magento\Framework\Controller\Result\JsonFactory;

class Stores implements HttpGetActionInterface, HttpPostActionInterface
{
    /** @var Installation */
    private $installationHelper;

    /** @var JsonFactory */
    private $resultJsonFactory;

    /**
     * @param Installation $installationHelper
     * @param JsonFactory $resultJsonFactory
     */
    public function __construct(
        Installation $installationHelper,
        JsonFactory $resultJsonFactory
    ) {
        $this->installationHelper = $installationHelper;
        $this->resultJsonFactory = $resultJsonFactory;
    }

    /**
     * Execute index action
     *
     * @return Json
     */
    public function execute(): Json
    {
        $data = $this->installationHelper->getStoresData();

        $resultJson = $this->resultJsonFactory->create();
        $resultJson->setData($data);

        return $resultJson;
    }
}
