<?php

namespace Glopal\Connector\Controller\Index;

use Glopal\Connector\Helper\Configuration;
use Glopal\Connector\Helper\ModuleData;
use Magento\Framework\App\ActionInterface;

/**
 * @SuppressWarnings(PHPMD.AllPurposeAction)
 */
class Index implements ActionInterface
{
    /** @var Configuration */
    private $configuration;

    /** @var ModuleData */
    private $helper;

    /**
     * @param Configuration $configuration
     * @param ModuleData $helper
     */
    public function __construct(
        Configuration $configuration,
        ModuleData $helper
    ) {
        $this->configuration = $configuration;
        $this->helper = $helper;
    }

    /**
     * Execute view action
     */
    public function execute()
    {
        // phpcs:disable
        if ($this->configuration->getGeneralFlag('signature_verification')
            && !$this->helper->verifyRequestSignature()
        ) {
            http_response_code(403);
            die;
        }

        define('GL_PASS_DB_LINK', $this->helper->isPassDbLinkEnabled());
        define('M1_TOKEN', $this->helper->getGlopalKey());
        define('M1_STORE_BASE_DIR', BP . DIRECTORY_SEPARATOR);
        define(
            'M1_BRIDGE_DOWNLOAD_LINK',
            (string)$this->configuration->getGeneralValue('bridge_file_update_url')
        );

        require_once __DIR__ . '/../../lib/bridge2cart/bridge.php.lib';
        die;
        // phpcs:enable
    }
}
