<?php

namespace Glopal\Connector\Helper;

use Magento\Framework\Serialize\SerializerInterface;

class CartTransfer
{
    /** @var SerializerInterface */
    private $serializer;

    /**
     * @param SerializerInterface $serializer
     */
    public function __construct(SerializerInterface $serializer)
    {
        $this->serializer = $serializer;
    }

    /**
     * Force serialize and unserialize data for avoiding objects inside.
     *
     * @param array $data
     *
     * @return array
     */
    public function convertQuoteDataToArray(array $data): array
    {
        return $this->serializer->unserialize($this->serializer->serialize($data));
    }

    /**
     * Filter quote data.
     *
     * @param array $data
     *
     * @return array
     */
    public function quoteFilterRecursive(array $data): array
    {
        foreach ($data as $key => &$value) {
            if ($key === 'uenc'
                || $key === 'info_buyRequest'
                || substr($key, 0, 6) === '_cache'
            ) {
                unset($data[$key]);
            } elseif (is_array($value)) {
                $data[$key] = $this->quoteFilterRecursive($value);
            }
        }

        return $data;
    }
}
