<?php

namespace Glopal\Connector\Helper;

use Glopal\Connector\Response\CartResponseBuilder;
use Magento\Quote\Api\Data\CartInterface;

class Data
{
    /** @var CartResponseBuilder */
    private $cartResponseBuilder;

    /**
     * @param CartResponseBuilder $cartResponseBuilder
     */
    public function __construct(CartResponseBuilder $cartResponseBuilder)
    {
        $this->cartResponseBuilder = $cartResponseBuilder;
    }

    /**
     * Build version 2 cart transfer data.
     *
     * @param CartInterface $quote
     * @param bool $encode
     *
     * @return array
     */
    public function buildVersion2Data(CartInterface $quote, bool $encode = true): array
    {
        return $this->cartResponseBuilder->build($quote, $encode);
    }
}
