<?php

namespace Glopal\Connector\Model\Config\Source;

use Magento\Framework\Data\OptionSourceInterface;

class InvoiceShippingAddress implements OptionSourceInterface
{
    public const DESTINATION_SHIPPING_ADDRESS_VALUE = 0;
    public const HUD_SHIPPING_ADDRESS_VALUE = 1;

    /**
     * Invoice shipping address source
     *
     * @return array
     */
    public function toOptionArray(): array
    {
        return [
            [
                'value' => self::DESTINATION_SHIPPING_ADDRESS_VALUE,
                'label' => __('Destination Shipping Address')
            ],
            [
                'value' => self::HUD_SHIPPING_ADDRESS_VALUE,
                'label' => __('Glopal PF Hub Address')
            ]
        ];
    }
}
