<?php

namespace Glopal\Connector\Model;

use Glopal\Connector\Api\Data\OrderItemTotalCostInterface;
use Glopal\Connector\Model\ResourceModel\OrderItemTotalCost as ResourceModel;
use Magento\Framework\Model\AbstractModel;

class OrderItemTotalCost extends AbstractModel implements OrderItemTotalCostInterface
{
    // phpcs:ignore
    protected function _construct()
    {
        $this->_init(ResourceModel::class);
    }

    /**
     * @inheritdoc
     */
    public function getId(): ?int
    {
        return $this->getData(self::ENTITY_ID);
    }

    /**
     * @inheritdoc
     */
    public function setId($id): void
    {
        $this->setData(self::ENTITY_ID, $id);
    }

    /**
     * @inheritdoc
     */
    public function getOrderItemId(): ?int
    {
        return $this->getData(self::ORDER_ITEM_ID);
    }

    /**
     * @inheritdoc
     */
    public function setOrderItemId(int $orderId): void
    {
        $this->setData(self::ORDER_ITEM_ID, $orderId);
    }

    /**
     * @inheritdoc
     */
    public function getOrderTccId(): ?int
    {
        return $this->getData(self::ORDER_TCC_ID);
    }

    /**
     * @inheritdoc
     */
    public function setOrderTccId(int $orderTccId): void
    {
        $this->setData(self::ORDER_TCC_ID, $orderTccId);
    }

    /**
     * @inheritdoc
     */
    public function getBaseDutyAmount(): float
    {
        return $this->getData(self::BASE_DUTY_AMOUNT) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setBaseDutyAmount(float $amount): void
    {
        $this->setData(self::BASE_DUTY_AMOUNT, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getDutyAmount(): float
    {
        return $this->getData(self::DUTY_AMOUNT) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setDutyAmount(float $amount): void
    {
        $this->setData(self::DUTY_AMOUNT, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getBaseTaxOnDutyAmount(): float
    {
        return $this->getData(self::BASE_TAX_ON_DUTY) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setBaseTaxOnDutyAmount(float $amount): void
    {
        $this->setData(self::BASE_TAX_ON_DUTY, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getTaxOnDutyAmount(): float
    {
        return $this->getData(self::TAX_ON_DUTY) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setTaxOnDutyAmount(float $amount): void
    {
        $this->setData(self::TAX_ON_DUTY, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getDutyPercent(): float
    {
        return $this->getData(self::DUTY_PERCENT) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setDutyPercent(float $percent): void
    {
        $this->setData(self::DUTY_PERCENT, $percent);
    }
}
