<?php

namespace Glopal\Connector\Model;

use Glopal\Connector\Api\Data\OrderTotalCostInterface;
use Glopal\Connector\Model\ResourceModel\OrderTotalCost as ResourceModel;
use Magento\Framework\Model\AbstractModel;

class OrderTotalCost extends AbstractModel implements OrderTotalCostInterface
{
    // phpcs:ignore
    protected function _construct()
    {
        $this->_init(ResourceModel::class);
    }

    /**
     * @inheritdoc
     */
    public function getId(): ?int
    {
        return $this->getData(self::ENTITY_ID);
    }

    /**
     * @inheritdoc
     */
    public function setId($id): void
    {
        $this->setData(self::ENTITY_ID, $id);
    }

    /**
     * @inheritdoc
     */
    public function getOrderId(): ?int
    {
        return $this->getData(self::ORDER_ID);
    }

    /**
     * @inheritdoc
     */
    public function setOrderId(int $orderId): void
    {
        $this->setData(self::ORDER_ID, $orderId);
    }

    /**
     * @inheritdoc
     */
    public function getBaseTotalDutyAmount(): float
    {
        return $this->getData(self::BASE_TOTAL_DUTY_AMOUNT) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setBaseTotalDutyAmount(float $amount): void
    {
        $this->setData(self::BASE_TOTAL_DUTY_AMOUNT, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getTotalDutyAmount(): float
    {
        return $this->getData(self::TOTAL_DUTY_AMOUNT) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setTotalDutyAmount(float $amount): void
    {
        $this->setData(self::TOTAL_DUTY_AMOUNT, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getBaseTotalTaxOnDutyAmount(): float
    {
        return $this->getData(self::BASE_TOTAL_TAX_ON_DUTY) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setBaseTotalTaxOnDutyAmount(float $amount): void
    {
        $this->setData(self::BASE_TOTAL_TAX_ON_DUTY, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getTotalTaxOnDutyAmount(): float
    {
        return $this->getData(self::TOTAL_TAX_ON_DUTY) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setTotalTaxOnDutyAmount(float $amount): void
    {
        $this->setData(self::TOTAL_TAX_ON_DUTY, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getBaseItemsDutyAmount(): float
    {
        return $this->getData(self::BASE_ITEMS_DUTY_AMOUNT) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setBaseItemsDutyAmount(float $amount): void
    {
        $this->setData(self::BASE_ITEMS_DUTY_AMOUNT, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getItemsDutyAmount(): float
    {
        return $this->getData(self::ITEMS_DUTY_AMOUNT) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setItemsDutyAmount(float $amount): void
    {
        $this->setData(self::ITEMS_DUTY_AMOUNT, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getBaseItemsTaxOnDutyAmount(): float
    {
        return $this->getData(self::BASE_ITEMS_TAX_ON_DUTY) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setBaseItemsTaxOnDutyAmount(float $amount): void
    {
        $this->setData(self::BASE_ITEMS_TAX_ON_DUTY, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getItemsTaxOnDutyAmount(): float
    {
        return $this->getData(self::ITEMS_TAX_ON_DUTY) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setItemsTaxOnDutyAmount(float $amount): void
    {
        $this->setData(self::ITEMS_TAX_ON_DUTY, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getBaseDiscountDutyAmount(): float
    {
        return $this->getData(self::BASE_DISCOUNT_DUTY_AMOUNT) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setBaseDiscountDutyAmount(float $amount): void
    {
        $this->setData(self::BASE_DISCOUNT_DUTY_AMOUNT, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getDiscountDutyAmount(): float
    {
        return $this->getData(self::DISCOUNT_DUTY_AMOUNT) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setDiscountDutyAmount(float $amount): void
    {
        $this->setData(self::DISCOUNT_DUTY_AMOUNT, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getBaseDiscountTaxOnDutyAmount(): float
    {
        return $this->getData(self::BASE_DISCOUNT_TAX_ON_DUTY) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setBaseDiscountTaxOnDutyAmount(float $amount): void
    {
        $this->setData(self::BASE_DISCOUNT_TAX_ON_DUTY, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getDiscountTaxOnDutyAmount(): float
    {
        return $this->getData(self::DISCOUNT_TAX_ON_DUTY) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setDiscountTaxOnDutyAmount(float $amount): void
    {
        $this->setData(self::DISCOUNT_TAX_ON_DUTY, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getBaseShippingDutyAmount(): float
    {
        return $this->getData(self::BASE_SHIPPING_DUTY_AMOUNT) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setBaseShippingDutyAmount(float $amount): void
    {
        $this->setData(self::BASE_SHIPPING_DUTY_AMOUNT, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getShippingDutyAmount(): float
    {
        return $this->getData(self::SHIPPING_DUTY_AMOUNT) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setShippingDutyAmount(float $amount): void
    {
        $this->setData(self::SHIPPING_DUTY_AMOUNT, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getBaseShippingTaxOnDutyAmount(): float
    {
        return $this->getData(self::BASE_SHIPPING_TAX_ON_DUTY) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setBaseShippingTaxOnDutyAmount(float $amount): void
    {
        $this->setData(self::BASE_SHIPPING_TAX_ON_DUTY, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getShippingTaxOnDutyAmount(): float
    {
        return $this->getData(self::SHIPPING_TAX_ON_DUTY) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setShippingTaxOnDutyAmount(float $amount): void
    {
        $this->setData(self::SHIPPING_TAX_ON_DUTY, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getBaseExtraDutyAmount(): float
    {
        return $this->getData(self::BASE_EXTRA_DUTY_AMOUNT) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setBaseExtraDutyAmount(float $amount): void
    {
        $this->setData(self::BASE_EXTRA_DUTY_AMOUNT, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getExtraDutyAmount(): float
    {
        return $this->getData(self::EXTRA_DUTY_AMOUNT) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setExtraDutyAmount(float $amount): void
    {
        $this->setData(self::EXTRA_DUTY_AMOUNT, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getBaseExtraTaxOnDutyAmount(): float
    {
        return $this->getData(self::BASE_EXTRA_TAX_ON_DUTY) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setBaseExtraTaxOnDutyAmount(float $amount): void
    {
        $this->setData(self::BASE_EXTRA_TAX_ON_DUTY, $amount);
    }

    /**
     * @inheritdoc
     */
    public function getExtraTaxOnDutyAmount(): float
    {
        return $this->getData(self::EXTRA_TAX_ON_DUTY) ?? 0.0;
    }

    /**
     * @inheritdoc
     */
    public function setExtraTaxOnDutyAmount(float $amount): void
    {
        $this->setData(self::EXTRA_TAX_ON_DUTY, $amount);
    }
}
