<?php

namespace Glopal\Connector\Model\Payment;

use Magento\Payment\Model\Method\AbstractMethod;
use Magento\Quote\Api\Data\CartInterface;
use Magento\Quote\Model\Quote;

class Glopal extends AbstractMethod
{
    public const PAYMENT_METHOD_GLOPAL_CODE = 'glopal';

    /**
     * Payment method code
     *
     * @var string
     */
    protected $_code = self::PAYMENT_METHOD_GLOPAL_CODE;

    /**
     * Availability option
     *
     * @var bool
     */
    protected $_isOffline = true;

    /**
     * Should not be available during checkout.
     *
     * @var bool
     */
    protected $_canUseCheckout = false;

    /**
     * Should not be available in admin.
     *
     * @var bool
     */
    protected $_canUseInternal = false;

    /**
     * Is active
     *
     * @param int|null $storeId
     *
     * @return bool
     *
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function isActive($storeId = null)
    {
        return true;
    }

    /**
     * Check whether method is available
     *
     * @param CartInterface|Quote|null $quote
     *
     * @return bool
     */
    public function isAvailable(CartInterface $quote = null)
    {
        if ($quote->getForcePaymentAvailability()) {
            return true;
        }

        return false;
    }
}
