<?php

namespace Glopal\Connector\Model\Price\Quote;

use Glopal\Connector\Api\Data\Price\QuoteItemDataInterface;

/**
 * @SuppressWarnings(PHPMD.TooManyFields)
 * phpcs:ignoreFile -- its DTO object
 */
class ItemData implements QuoteItemDataInterface
{
    /**@#+
     * Quote item prices.
     *
     * @var float
     */
    private $originalPrice;
    private $baseOriginalPrice;
    private $price;
    private $basePrice;
    private $priceInclTax;
    private $basePriceInclTax;
    private $taxBeforeDiscount;
    private $baseTaxBeforeDiscount;
    private $taxAmount;
    private $baseTaxAmount;
    private $rowTotal;
    private $baseRowTotal;
    private $rowTotalInclTax;
    private $baseRowTotalInclTax;
    private $rowTotalWithDiscount;
    private $discountAmount;
    private $baseDiscountAmount;
    private $discountTaxCompensationAmount;
    private $baseDiscountTaxCompensationAmount;
    /**@#-*/

    /**
     * @inheritdoc
     */
    public function getOriginalPrice(): float
    {
        return $this->originalPrice;
    }

    public function setOriginalPrice(float $originalPrice): QuoteItemDataInterface
    {
        $this->originalPrice = $originalPrice;

        return $this;
    }

    public function getBaseOriginalPrice(): float
    {
        return $this->baseOriginalPrice;
    }

    public function setBaseOriginalPrice(float $baseOriginalPrice): QuoteItemDataInterface
    {
        $this->baseOriginalPrice = $baseOriginalPrice;

        return $this;
    }

    public function getPrice(): float
    {
        return $this->price;
    }

    public function setPrice(float $price): QuoteItemDataInterface
    {
        $this->price = $price;

        return $this;
    }

    public function getBasePrice(): float
    {
        return $this->basePrice;
    }

    public function setBasePrice(float $basePrice): QuoteItemDataInterface
    {
        $this->basePrice = $basePrice;

        return $this;
    }

    public function getPriceInclTax(): float
    {
        return $this->priceInclTax;
    }

    public function setPriceInclTax(float $priceInclTax): QuoteItemDataInterface
    {
        $this->priceInclTax = $priceInclTax;

        return $this;
    }

    public function getBasePriceInclTax(): float
    {
        return $this->basePriceInclTax;
    }

    public function setBasePriceInclTax(float $basePriceInclTax): QuoteItemDataInterface
    {
        $this->basePriceInclTax = $basePriceInclTax;

        return $this;
    }

    public function getTaxBeforeDiscount(): float
    {
        return $this->taxBeforeDiscount;
    }

    public function setTaxBeforeDiscount(float $taxBeforeDiscount): QuoteItemDataInterface
    {
        $this->taxBeforeDiscount = $taxBeforeDiscount;

        return $this;
    }

    public function getBaseTaxBeforeDiscount(): float
    {
        return $this->baseTaxBeforeDiscount;
    }

    public function setBaseTaxBeforeDiscount(float $baseTaxBeforeDiscount): QuoteItemDataInterface
    {
        $this->baseTaxBeforeDiscount = $baseTaxBeforeDiscount;

        return $this;
    }

    public function getTaxAmount(): float
    {
        return $this->taxAmount;
    }

    public function setTaxAmount(float $taxAmount): QuoteItemDataInterface
    {
        $this->taxAmount = $taxAmount;

        return $this;
    }

    public function getBaseTaxAmount(): float
    {
        return $this->baseTaxAmount;
    }

    public function setBaseTaxAmount(float $baseTaxAmount): QuoteItemDataInterface
    {
        $this->baseTaxAmount = $baseTaxAmount;

        return $this;
    }

    public function getRowTotal(): float
    {
        return $this->rowTotal;
    }

    public function setRowTotal(float $rowTotal): QuoteItemDataInterface
    {
        $this->rowTotal = $rowTotal;

        return $this;
    }

    public function getBaseRowTotal(): float
    {
        return $this->baseRowTotal;
    }

    public function setBaseRowTotal(float $baseRowTotal): QuoteItemDataInterface
    {
        $this->baseRowTotal = $baseRowTotal;

        return $this;
    }

    public function getRowTotalInclTax(): float
    {
        return $this->rowTotalInclTax;
    }

    public function setRowTotalInclTax(float $rowTotalInclTax): QuoteItemDataInterface
    {
        $this->rowTotalInclTax = $rowTotalInclTax;

        return $this;
    }

    public function getBaseRowTotalInclTax(): float
    {
        return $this->baseRowTotalInclTax;
    }

    public function setBaseRowTotalInclTax(float $baseRowTotalInclTax): QuoteItemDataInterface
    {
        $this->baseRowTotalInclTax = $baseRowTotalInclTax;

        return $this;
    }

    public function getRowTotalWithDiscount(): float
    {
        return $this->rowTotalWithDiscount;
    }

    public function setRowTotalWithDiscount(float $rowTotalWithDiscount): QuoteItemDataInterface
    {
        $this->rowTotalWithDiscount = $rowTotalWithDiscount;

        return $this;
    }

    public function getDiscountAmount(): float
    {
        return $this->discountAmount;
    }

    public function setDiscountAmount(float $discountAmount): QuoteItemDataInterface
    {
        $this->discountAmount = $discountAmount;

        return $this;
    }

    public function getBaseDiscountAmount(): float
    {
        return $this->baseDiscountAmount;
    }

    public function setBaseDiscountAmount(float $baseDiscountAmount): QuoteItemDataInterface
    {
        $this->baseDiscountAmount = $baseDiscountAmount;

        return $this;
    }

    public function getDiscountTaxCompensationAmount(): float
    {
        return $this->discountTaxCompensationAmount;
    }

    public function setDiscountTaxCompensationAmount(float $discountTaxCompensationAmount): QuoteItemDataInterface
    {
        $this->discountTaxCompensationAmount = $discountTaxCompensationAmount;

        return $this;
    }

    public function getBaseDiscountTaxCompensationAmount(): float
    {
        return $this->baseDiscountTaxCompensationAmount;
    }

    public function setBaseDiscountTaxCompensationAmount(float $baseDiscountTaxCompensationAmount): QuoteItemDataInterface
    {
        $this->baseDiscountTaxCompensationAmount = $baseDiscountTaxCompensationAmount;

        return $this;
    }
}
