<?php

namespace Glopal\Connector\Plugin\Checkout\Block;

use Glopal\Connector\Helper\Configuration;
use Magento\Checkout\Block\Cart;
use Magento\Checkout\Block\Cart\Sidebar;
use Magento\Checkout\Block\Onepage\Link;
use Magento\Framework\UrlInterface;

/**
 * @SuppressWarnings(PHPMD.UnusedFormalParameter)
 */
class ReplaceCheckoutUrlPlugin
{
    /** @var Configuration */
    private $configuration;

    /** @var UrlInterface */
    private $urlBuilder;

    /**
     * @param Configuration $configuration
     * @param UrlInterface $urlBuilder
     */
    public function __construct(Configuration $configuration, UrlInterface $urlBuilder)
    {
        $this->configuration = $configuration;
        $this->urlBuilder = $urlBuilder;
    }

    /**
     * After get checkout url plugin.
     *
     * Use only for method 'getCheckoutUrl()' - same definition in three classes.
     *
     * @param Cart|Link|Sidebar $subject
     * @param string $result
     *
     * @return string
     */
    public function afterGetCheckoutUrl($subject, string $result): string
    {
        if (!$this->configuration->getCheckoutValue('general/is_redirect_enabled')) {
            return $result;
        }

        return $this->urlBuilder->getUrl('glopal_connector/checkout/index');
    }
}
