<?php

namespace Glopal\Connector\Plugin\Checkout\Controller\Index;

use Closure;
use Glopal\Connector\Helper\Configuration;
use Magento\Checkout\Controller\Index\Index as CheckoutController;
use Magento\Framework\Controller\Result\Forward;
use Magento\Framework\Controller\ResultFactory;
use Magento\Framework\Controller\ResultInterface;

/**
 * @SuppressWarnings(PHPMD.UnusedFormalParameter)
 */
class RedirectCheckoutPlugin
{
    /** @var ResultFactory */
    private $resultFactory;

    /** @var Configuration */
    private $configuration;

    /**
     * @param ResultFactory $resultFactory
     * @param Configuration $configuration
     */
    public function __construct(ResultFactory $resultFactory, Configuration $configuration)
    {
        $this->resultFactory = $resultFactory;
        $this->configuration = $configuration;
    }

    /**
     * Around default Magento Checkout controller plugin.
     *
     * @param CheckoutController $subject
     * @param Closure $proceed
     *
     * @return Forward|ResultInterface
     */
    public function aroundExecute(CheckoutController $subject, Closure $proceed)
    {
        if (!$this->configuration->getCheckoutValue('general/is_redirect_enabled')) {
            return $proceed();
        }

        return $this->resultFactory->create(ResultFactory::TYPE_FORWARD)
            ->setModule('glopal_connector')
            ->setController('checkout')
            ->forward('index');
    }
}
