<?php

namespace Glopal\Connector\Plugin;

use Closure;
use Magento\Framework\App\ActionInterface;
use Magento\Framework\App\Request\CsrfValidator as CsrfValidatorBase;
use Magento\Framework\App\RequestInterface;

/**
 * @SuppressWarnings(PHPMD.UnusedFormalParameter)
 */
class CsrfValidator
{
    /**
     * Around validate.
     *
     * @param CsrfValidatorBase $subject
     * @param Closure $proceed
     * @param RequestInterface $request
     * @param ActionInterface $action
     */
    public function aroundValidate(
        CsrfValidatorBase $subject,
        Closure $proceed,
        RequestInterface $request,
        ActionInterface $action
    ) {
        if (in_array($request->getModuleName(), ['glopal_connector', 'webinterpret_connector'])
            && in_array($request->getControllerName(), ['index', 'configuration', 'checkout', 'quote', 'v1'])
        ) {
            // Skip CSRF check for Magento 2.3+
            return;
        }

        $proceed($request, $action);
    }
}
