<?php

namespace Glopal\Connector\Processor\AfterOrder;

use Glopal\Connector\Api\CreateRequestDTOInterface;
use Magento\Sales\Api\Data\OrderInterface;
use Magento\Sales\Model\Order;

class Comment implements AfterOrderCreateProcessorInterface
{
    /**
     * @inheritdoc
     */
    public function process(OrderInterface $order, CreateRequestDTOInterface $createRequestDTO): void
    {
        if (!empty($createRequestDTO->getInternalNote())) {
            $order->addCommentToStatusHistory($createRequestDTO->getInternalNote(), Order::STATE_PROCESSING);
        } else {
            $order->setStatus(Order::STATE_PROCESSING);
        }
    }
}
