<?php

namespace Glopal\Connector\Processor\CartTransfer;

use Glopal\Connector\Provider\CartTransfer\CallBackUrlsProvider;
use Magento\Quote\Api\Data\CartInterface;

class Checkout implements CartTransferProcessorInterface
{
    private const KEY = 'wi_checkout';

    /** @var CallBackUrlsProvider */
    private $callBackUrlsProvider;

    /**
     * @param CallBackUrlsProvider $callBackUrlsProvider
     */
    public function __construct(CallBackUrlsProvider $callBackUrlsProvider)
    {
        $this->callBackUrlsProvider = $callBackUrlsProvider;
    }

    /**
     * @inheritdoc
     */
    public function process(CartInterface $quote, array &$data): void
    {
        $storeId = $quote->getStoreId();

        $data[self::KEY] = [
            'inventory_check' => $this->callBackUrlsProvider->getInventoryCheckUrl($storeId),
            'checkout_purchase' => $this->callBackUrlsProvider->getCheckoutPurchaseUrl($quote, $storeId)
        ];
    }
}
