<?php

namespace Glopal\Connector\Processor\CartTransfer;

use Magento\Framework\UrlInterface;
use Magento\Quote\Api\Data\CartInterface;

class General implements CartTransferProcessorInterface
{
    private const KEY_BASE_URL = 'wi_base_url';
    private const KEY_CART_URL = 'wi_cart_url';

    /** @var UrlInterface */
    private $urlBuilder;

    /**
     * @param UrlInterface $urlBuilder
     */
    public function __construct(UrlInterface $urlBuilder)
    {
        $this->urlBuilder = $urlBuilder;
    }

    /**
     * @inheritdoc
     */
    public function process(CartInterface $quote, array &$data): void
    {
        $data[self::KEY_BASE_URL] = $this->urlBuilder->getBaseUrl(UrlInterface::URL_TYPE_WEB);
        $data[self::KEY_CART_URL] = $this->urlBuilder->getUrl('checkout/cart');
    }
}
