<?php

namespace Glopal\Connector\Processor\CartTransfer;

use Glopal\Connector\Helper\Configuration;
use Magento\Quote\Api\Data\CartInterface;

class TaxOptions implements CartTransferProcessorInterface
{
    private const KEY = 'wi_tax_options';

    /** @var Configuration */
    private $configuration;

    /** @var array */
    private $configPathPool;

    /**
     * @param Configuration $configuration
     * @param array $configPathPool
     */
    public function __construct(Configuration $configuration, array $configPathPool)
    {
        $this->configuration = $configuration;
        $this->configPathPool = $configPathPool;
    }

    /**
     * @inheritdoc
     */
    public function process(CartInterface $quote, array &$data): void
    {
        $result = [];
        $storeId = $quote->getStoreId();

        foreach ($this->configPathPool as $key => $path) {
            $result[$key] = $this->configuration->getValue($path, $storeId);
        }

        $data[self::KEY] = $result;
    }
}
