<?php

namespace Glopal\Connector\Processor\Order;

use Glopal\Connector\Api\CreateRequestDTOInterface;
use Magento\Quote\Api\Data\CartInterface;

class Discount implements OrderCreateProcessorInterface
{
    /**
     * @inheritdoc
     */
    public function process(CartInterface $quote, CreateRequestDTOInterface $createRequestDTO): void
    {
        $discountData = $createRequestDTO->getDiscounts();

        if (empty($discountData)) {
            return;
        }

        $summaryData = $createRequestDTO->getSummary();
        $exchangeRate = $createRequestDTO->getExchangeRate();

        $subtotalWithDiscount = $summaryData['items']['amount_net'] - $summaryData['discounts']['amount_net'];

        $quote->setBaseSubtotalWithDiscount($subtotalWithDiscount / $exchangeRate);
        $quote->setSubtotalWithDiscount($subtotalWithDiscount);
    }
}
