<?php

namespace Glopal\Connector\Processor\Order;

use Glopal\Connector\Api\CreateRequestDTOInterface;
use Glopal\Connector\Model\Payment\Glopal;
use Magento\Framework\Exception\LocalizedException;
use Magento\Quote\Api\Data\CartInterface;

class Payment implements OrderCreateProcessorInterface
{
    /**
     * Always sets the Glopal payment method.
     *
     * @param CartInterface $quote
     * @param CreateRequestDTOInterface $createRequestDTO
     * @return void
     * @throws LocalizedException
     */
    public function process(CartInterface $quote, CreateRequestDTOInterface $createRequestDTO): void
    {
        // Prevent collection totals for Glopal Payment.
        $quote->setTotalsCollectedFlag(true);
        $quote->getPayment()->setQuote($quote)->importData(['method' => Glopal::PAYMENT_METHOD_GLOPAL_CODE]);
    }
}
