<?php

namespace Glopal\Connector\Processor\Order;

use Glopal\Connector\Api\CreateRequestDTOInterface;
use Magento\Quote\Api\Data\CartInterface;

class QuoteTotals implements OrderCreateProcessorInterface
{
    /**
     * @inheritdoc
     */
    public function process(CartInterface $quote, CreateRequestDTOInterface $createRequestDTO): void
    {
        $exchangeRate = $createRequestDTO->getExchangeRate();
        $totals = $createRequestDTO->getMagentoTotals();

        $quote->setSubtotal($totals['subtotal'])
            ->setBaseSubtotal($totals['base_subtotal'] / $exchangeRate)
            ->setGrandTotal($totals['grand_total'])
            ->setBaseGrandTotal($totals['base_grand_total'] / $exchangeRate);
    }
}
