<?php

namespace Glopal\Connector\Profiler;

use Magento\Framework\Profiler\DriverInterface;

class Driver implements DriverInterface
{
    /** @var int */
    private $count = 0;
    /** @var array */
    private $observerList = [];

    /**
     * @inheritdoc
     */
    public function start($timerId, array $tags = null)
    {
        if (preg_match('/OBSERVER:(.+)/', $timerId, $matches)) {
            $this->count++;
            $this->observerList[] = $matches[1];
        }
    }

    /**
     * @inheritdoc
     */
    public function stop($timerId) // phpcs:ignore
    {
    }

    /**
     * Gets count.
     *
     * @return int
     */
    public function getCount(): int
    {
        return $this->count;
    }

    /**
     * Gets observer list.
     *
     * @return array
     */
    public function getObserverList(): array
    {
        return $this->observerList;
    }

    /**
     * @inheritdoc
     */
    public function clear($timerId = null)
    {
        $this->count = 0;
        $this->observerList = [];
    }
}
