<?php

namespace Glopal\Connector\Provider\CartTransfer;

use Magento\Catalog\Api\Data\ProductInterface;

class CombineProductDataProvider
{
    /**
     * Combine product data, with specific attributes.
     *
     * @param ProductInterface $modelProduct
     * @param ProductInterface $itemProduct
     *
     * @return array
     */
    public function get(
        ProductInterface $modelProduct,
        ProductInterface $itemProduct
    ): array {
        $productData = $modelProduct->getData();

        foreach ($itemProduct->getData() as $itemProductKey => $itemProductDatum) {
            if (!empty($itemProductDatum)) {
                $productData[$itemProductKey] = $itemProductDatum;
            }
        }

        return $productData;
    }
}
