<?php

namespace Glopal\Connector\Provider\CartTransfer;

use Magento\Catalog\Api\Data\ProductInterface;

class OrderOptionsProvider
{
    /**
     * Format order options.
     *
     * @param array $orderOptions
     * @param null|ProductInterface $simpleProduct
     *
     * @return array|null
     */
    public function get(array $orderOptions, ?ProductInterface $simpleProduct): ?array
    {
        $data = [];
        if ($orderOptions) {
            $data = $orderOptions;
        }

        if (null !== $simpleProduct && $simpleProduct->getId()) {
            $data['wi_variant_id'] = $simpleProduct->getId();
            $data['wi_variant_weight'] = $simpleProduct->getWeight();
        }

        if (!empty($orderOptions['attributes_info'])) {
            $attributes = $orderOptions['attributes_info'];

            if (!empty($orderOptions['info_buyRequest']['super_attribute'])) {
                $i = 0;
                foreach ($orderOptions['info_buyRequest']['super_attribute'] as $key => $value) {
                    $attributes[$i]['option_id'] = $key;
                    $attributes[$i]['value_id'] = $value;
                    $i++;
                }
            }

            $data['wi_attributes_merged'] = $attributes;
        }

        return empty($data) ? null : $data;
    }
}
