<?php

namespace Glopal\Connector\Provider;

use Glopal\Connector\Helper\Configuration;

class GlopalKeysOptionsProvider
{
    /** @var Configuration */
    private $configuration;

    /**
     * @param Configuration $configuration
     */
    public function __construct(Configuration $configuration)
    {
        $this->configuration = $configuration;
    }

    /**
     * Get options.
     *
     * @return array
     */
    public function getOptions(): array
    {
        $options = [];
        $configData = $this->configuration->getCartProductDataValue('extra_keys_names');

        foreach ($configData as $datum) {
            $options[] = [
                'label' => $datum['title'],
                'value' => $datum['code']
            ];
        }

        return $options;
    }
}
