<?php

namespace Glopal\Connector\Setup\Patch\Data;

use Magento\Config\Model\ResourceModel\Config;
use Magento\Framework\Setup\ModuleDataSetupInterface;
use Magento\Framework\Setup\Patch\DataPatchInterface;

class AdjustPaymentMethodConfiguration implements DataPatchInterface
{
    /** @var ModuleDataSetupInterface */
    private $moduleDataSetup;

    /** @var Config */
    private $resourceConfig;

    /** @var array */
    private $glopalPaymentConfigValuesMap = [
        'payment/glopal/can_use_checkout' => 0,
        'payment/glopal/can_use_internal' => 0,
        'payment/glopal/sort_order' => 999,
    ];

    /**
     * @param ModuleDataSetupInterface $moduleDataSetup
     * @param Config $resourceConfig
     */
    public function __construct(ModuleDataSetupInterface $moduleDataSetup, Config $resourceConfig)
    {
        $this->moduleDataSetup = $moduleDataSetup;
        $this->resourceConfig = $resourceConfig;
    }

    /**
     * @inheritdoc
     */
    public function apply()
    {
        $connection = $this->moduleDataSetup->getConnection();
        $connection->startSetup();

        foreach ($this->glopalPaymentConfigValuesMap as $path => $value) {
            $this->resourceConfig->saveConfig($path, $value);
        }

        $connection->endSetup();

        return $this;
    }

    /**
     * @inheritdoc
     */
    public static function getDependencies()
    {
        return [];
    }

    /**
     * @inheritdoc
     */
    public function getAliases()
    {
        return [];
    }
}
