<?php

namespace Glopal\Connector\Test\Unit\Provider\CartTransfer;

use Glopal\Connector\Provider\CartTransfer\CombineProductDataProvider;
use Magento\Catalog\Api\Data\ProductInterface;
use PHPUnit\Framework\TestCase;

// phpcs:ignoreFile
class CombineProductDataProviderTest extends TestCase
{
    public function testGetCombinedProductData(): void
    {
        $modelProduct = $this->getMockForAbstractClass(
            ProductInterface::class,
            [],
            '',
            false,
            false,
            true,
            ['getData']
        );
        $itemProduct = $this->getMockForAbstractClass(
            ProductInterface::class,
            [],
            '',
            false,
            false,
            true,
            ['getData']
        );

        $modelProduct->method('getData')->willReturn([
            'name' => 'Model Product',
            'description' => 'This is the model product',
        ]);
        $itemProduct->method('getData')->willReturn([
            'name' => 'Item Product',
            'price' => 15.00,
        ]);

        $combineProductDataProvider = new CombineProductDataProvider();
        $combinedData = $combineProductDataProvider->get($modelProduct, $itemProduct);

        $this->assertEquals('Item Product', $combinedData['name']);
        $this->assertEquals('This is the model product', $combinedData['description']);
        $this->assertEquals(15.00, $combinedData['price']);
    }
}
