<?php

namespace Glopal\Connector\Validator\OrderCreate;

class Shipping extends BaseOrderCreate
{
    private const REQUIRED_FIELDS = [
        'service_method',  // Replacement for 'service_code'
    ];

    private const OPTIONAL_FIELDS = [
        'service_type',    // PARCEL_FORWARDING or SELLER
        'service_code',   // Magento shipping code (if using shipping from Magento)
        'display_name',   // Optional custom shipping method name
    ];

    /**
     * @inheritdoc
     */
    public function validate(array $data): void
    {
        $data = $data['shipping'];
        $this->validateFieldsWithData(self::REQUIRED_FIELDS, $data);
        $this->validateOptionalFields(self::OPTIONAL_FIELDS, $data);
    }
}
