<?php

namespace Glopal\Connector\Validator\OrderCreate;

class Summary extends BaseOrderCreate
{
    private const REQUIRED_FIELDS = [
        'items',
        'discounts',
        'shipping',
        'extra',
        'total'
    ];

    /**
     * @inheritdoc
     */
    public function validate(array $data): void
    {
        $data = $data['summary'];
        $this->validateFieldsWithData(self::REQUIRED_FIELDS, $data);

        foreach (self::REQUIRED_FIELDS as $field) {
            $this->validateCharge("summary.{$field}", $data[$field]);
        }
    }
}
