define([
    'jquery'
], function ($) {
    'use strict';

    return function () {
        let attributeSetSelector = '.product-attribute-set-dropdown';

        function processOptionsAvailability(selectElement) {
            let rowId = $(selectElement).closest('tr').attr('id'),
                selectedAttributeSetValue = $(selectElement).val(),
                relatedAttributeDropDownOptions = $('#' + rowId + '_product_attribute option');

            relatedAttributeDropDownOptions.each(function(index) {
                let optionElement = $(this),
                    // Fix issues when js converts string into integer
                    availableSetIds = optionElement.data('attribute-set-id') + '';

                if (!availableSetIds.trim()) {
                    return;
                }

                let availableSetIdsArray = availableSetIds.split(',');
                if ($.inArray(selectedAttributeSetValue, availableSetIdsArray) === -1) {
                    optionElement.css('display', 'none');
                } else {
                    optionElement.css('display', '');
                }
            });
        }

        // Processing availability after load saved attribute set from db
        $(attributeSetSelector).each(function(index) {
            processOptionsAvailability(this);
        });

        // Processing availability after select attribute set
        $('body').on('change', attributeSetSelector, function() {
            processOptionsAvailability(this);
        });
    };
});
